
#   pkgIndex.tcl   -  Common packages used by MIDAS


proc do_load-package {package version} {
    global env 

    set dir [file join $env(MIDASBASE) MIDASpackages $package$version]
    if {![file exists $dir] || ![file isdirectory $dir]}  then {return}

    set f [file join $dir pkgIndex.tcl]
    if {[file exists $f]} then {source $f; return}

    set f [file join $dir $env(OpSys)]
    if {![file exists $f]} {set f [file join $dir [string tolower $env(OpSys)]]}
    if {![file exists $f] || ![file isdirectory $f]} {
       if {$env(MIDASPACKAGEWARNINGS)} \
         {puts stderr "package not supported for this system - $f $env(os) $env(machine) (no directory)"}
       return
    }
    set f [file join $f lib[set package][info sharedlibextension]]
    if {![file exists $f]} {
       if {$env(MIDASPACKAGEWARNINGS)} \
         {puts stderr "package not supported for this system - $f $env(os) $env(machine) (no library)"}
       return
    }
    package ifneeded $package $version [list load $f $package]

    set f [file join $dir $package.tcl]
    if {[file exists $f]} then {source $f; return}

#    puts stdout "package ifneeded $package $version  load $f $package"

}


#    puts stdout "Setting up access for MIDAS packages"
    
     do_load-package Hello 1.0
     do_load-package Time 1.0

     do_load-package NetVarCmd 1.0
     do_load-package NetVarsCmd 1.1

     do_load-package ABCAccess 1.0
     do_load-package CAENVx718 1.0
     do_load-package EPICSAccess 1.0
     do_load-package EPICSClientAccess 1.0
     do_load-package HytecPCI5992 1.0
     do_load-package HytecVSD2992 1.0
     do_load-package KnobEncoder 1.0
     do_load-package LaserCmd 1.0
     do_load-package MPXAccess 1.0
     do_load-package SetEventCmd 1.0
     do_load-package TapeServerCmd 1.0
     do_load-package TDRIAccess 1.0
     do_load-package VHSADC 1.0
     do_load-package VMEAccess 1.0
     do_load-package XportAccess 1.0
     do_load-package XPRAYSNUCAMAccess 1.0
     do_load-package XPGRISAccess 1.0
     do_load-package XAIDAAccess 1.0
     do_load-package XAD9252Access 1.0
     do_load-package XR3BAccess 1.0
     do_load-package XR3BASICAccess 1.0

     do_load-package MemSasAccess 1.0
     do_load-package DiscSasAccess 1.0




